<template>
  <div class="app-container">
    <div class="filter-container">
      <div class="block">
        <el-date-picker v-model="yearDate" :clearable="false" type="month" placeholder="选择年" />
      </div>
    </div>

    <el-row v-if="isChart1" style="position: relative;">
      <p style="position: absolute;top:-12px;left:40%;color:rgb(130, 165, 252);background:rgb(230, 243, 255);border:1px solid rgb(130, 165, 252);padding:10px;border-radius:10px">
        {{ year }}年集团用电量：{{ total }}万千瓦
      </p>
       <el-radio-group v-model="radio1" class="group" @change="changeGroup('1')">
          <el-radio :label="1">集团</el-radio>
          <el-radio :label="2">一中心</el-radio>
          <el-radio :label="3">二中心</el-radio>
          <el-radio :label="4">三中心</el-radio>
        </el-radio-group>
      <el-col :span="24">
        <div id="chart1" style="width: 100%;height:400px;" />
      </el-col>
    </el-row>

    <el-row style="position: relative;">
       <el-radio-group v-model="radio2" class="group" @change="changeGroup('2')">
          <el-radio :label="1">集团</el-radio>
          <el-radio :label="2">一中心</el-radio>
          <el-radio :label="3">二中心</el-radio>
          <el-radio :label="4">三中心</el-radio>
        </el-radio-group>
      <el-col :span="24">
        <div id="chart2" style="width: 100%;height:400px;" />
      </el-col>
    </el-row>

    <el-row style="position: relative;">
       <el-radio-group v-model="radio3" class="group" @change="changeGroup('3')">
          <el-radio :label="1">集团</el-radio>
          <el-radio :label="2">一中心</el-radio>
          <el-radio :label="3">二中心</el-radio>
          <el-radio :label="4">三中心</el-radio>
        </el-radio-group>
      <el-col :span="24">
        <div id="chart3" style="width: 100%;height:400px;" />
      </el-col>
    </el-row>
    <el-row style="position: relative;">
      <el-col :span="12">
        <div style="height: 50px;">
          <el-select style="float: right;margin-right: 20px;" v-model="getChart4Parm.parammaps.pastureName" multiple :multiple-limit="5" collapse-tags placeholder="牧场" @change="changePasture('4')">
            <el-option v-for="item in pastureList" :key="item.id" :label="item.name" :value="item.name"> </el-option>
          </el-select>
        </div>
        <div id="chart4" style="width: 100%;height:400px;" />
      </el-col>
      <el-col :span="12">
        <div style="height: 50px;">
          <el-select style="float: right;margin-right: 20px;" v-model="getChart5Parm.parammaps.deptName" placeholder="部门" @change="changeDept('5')">
            <el-option v-for="item in deptList" :key="item.id" :label="item.name" :value="item.name"> </el-option>
          </el-select>
        </div>
        <div id="chart5" style="width: 100%;height:400px;" />
      </el-col>
    </el-row>

    <el-row style="position: relative;">
      <el-col :span="12">
        <div style="height: 50px;" />
        <div id="chart6" style="width: 100%;height:400px;" />
      </el-col>
      <el-col :span="12">
        <div style="height: 50px;">
          <el-select style="float: right;margin-right: 20px;" v-model="getChart7Parm.parammaps.pastureName" multiple :multiple-limit="5" collapse-tags placeholder="牧场" @change="changePasture('7')">
            <el-option v-for="item in pastureList" :key="item.id" :label="item.name" :value="item.name"> </el-option>
          </el-select>
        </div>
        <div id="chart7" style="width: 100%;height:400px;" />
      </el-col>
    </el-row>
  </div>

</template>

<script>
import echarts from 'echarts'
import { GetDataByName,GetDataByNames, GetReportform, checkButtons } from '@/api/common'
import Cookies from 'js-cookie'
import { parseTime } from '@/utils/index.js'
export default {
  name: 'QueryElec',
  data() {
    return {
      yearDate: new Date(),
      year: new Date().getFullYear(),
      month: new Date().getMonth() < 9 ? '0' + (new Date().getMonth() + 1) : new Date().getMonth() + 1,
      pastureList:[],
      deptList:[],
      total: '',
      radio1:1,
      isChart1: [],
      chart_data1: {},
      getChart1Parm: {
        name: 'getpSumNowWater',
        parammaps: {
          receiveTime: new Date().getFullYear(),
          pastureName: Cookies.get('pasturename')
        }
      },
      radio2:1,
      isChart2: [],
      chart_data2: {},
      getChart2Parm: {
        name: 'getpSumNowWater',
        parammaps: {
          receiveTime: new Date().getFullYear(),
          pastureName: Cookies.get('pasturename')
        }
      },

      radio3:1,
      isChart3: [],
      chart_data3: {},
      getChart3Parm: {
        name: 'getpSumNowWater',
        parammaps: {
          receiveTime: new Date().getFullYear(),
          pastureName: Cookies.get('pasturename')
        }
      },


      isChart4: [],
      chart_data4: {},
      getChart4Parm: {
        name: 'getpSumNowWater',
        parammaps: {
          receiveTime: new Date().getFullYear(),
          pastureName: Cookies.get('pasturename')
        }
      },

      isChart5: [],
      chart_data5: {},
      getChart5Parm: {
        name: 'getpSumNowWater',
        parammaps: {
          receiveTime: new Date().getFullYear(),
          pastureName: Cookies.get('pasturename'),
          deptName:''
        }
      },

      isChart6: [],
      chart_data6: {},
      getChart6Parm: {
        name: 'getpSumNowWater',
        parammaps: {
          receiveTime: new Date().getFullYear(),
          pastureName: Cookies.get('pasturename')
        }
      },
      isChart7: [],
      chart_data7: {},
      getChart7Parm: {
        name: 'getpSumNowWater',
        parammaps: {
          receiveTime: new Date().getFullYear(),
          pastureName: Cookies.get('pasturename')
        }
      },
    }
  },
  created() {
    this.get_select_list()
    this.getChart1()
    this.getChart2()
    this.getChart3()
    this.getChart4()
    this.getChart5()
    this.getChart6()
    this.getChart7()
    const that = this
    GetDataByName({ 'name': 'getUserPCButtons', 'parammaps': { 'jwt_username': Cookies.get('name') }}).then(response => {
      that.buttons = response.data.list
      that.get_auto_buttons()
    })
  },
  mounted() {
  },
  methods: {
    get_select_list() {
      var send_data =  [
        { name: 'findAllPasture', offset: 0, pagecount: 0, returntype: 'Map', parammaps: { 'id': Cookies.get('pastureid') }},
      ]
      GetDataByNames(send_data).then(response => {
        this.pastureList = response.data.findAllPasture.list
      })
    },
    changeGroup(item){
      if(item == 1){
        this.getChart1()
      }else if(item == 2){
        this.getChart2()
      }else if(item == 3){
        this.getChart3()
      }
    },
    changePasture(item){
      if(item == 4){
        this.getChart4()
      }else if(item == 7){
        this.getChart7()
      }
    },
    changeDept(item){
      if(item == 5){
        this.getChart5()
      }
    },
    get_auto_buttons() {
      // 图1
      const chart1 = 'report:queryWater:pastures'
      const isChart1 = checkButtons(this.$store.state.user.buttons, chart1)
      this.isChart1 = isChart1
    },
    // 各牧场年度用水量对比
    getChart1() {
      GetReportform(this.getChart1Parm).then(response => {
        console.log('图1', response)
        // this.chart_data1 = response.data.chart_data
        this.chart_data1 = {
          data1:[10,20,30,40,50],
          data2:[20,30,40,50,60],
          xdata:["马鞍山牧场", "汶上牧场", "商河牧场", "合肥牧场", "蚌埠牧场"]
        }
        this.roadChart1(this.chart_data1)
        var nowYear = response.data.chart_data.nowYear
        var total = 0
        if (nowYear !== null || nowYear !== undefined) {
          nowYear.forEach(function(item, index) {
            total = total + parseFloat(item)
          })
        }
        this.total = total.toFixed(2)
      })
    },
    // 单头牛水量
    getChart2() {
      GetReportform(this.getChart2Parm).then(response => {
        console.log('图2', response)
        // this.chart_data2 = response.data.chart_data
        this.chart_data2 = {
          data1:[10,20,30,40,50],
          data2:[20,30,40,50,60],
          xdata:["马鞍山牧场", "汶上牧场", "商河牧场", "合肥牧场", "蚌埠牧场"]
        }
        this.roadChart2(this.chart_data2)
      })
    },

    // 单头牛水费
    getChart3() {
      GetReportform(this.getChart3Parm).then(response => {
        console.log('图3', response)
        // this.chart_data3 = response.data.chart_data
        this.chart_data3 = {
          data1:[10,20,30,40,50],
          data2:[20,30,40,50,60],
          data3:[30,40,50,60,70],
          xdata:["马鞍山牧场", "汶上牧场", "商河牧场", "合肥牧场", "蚌埠牧场"]
        }
        this.roadChart3(this.chart_data3)
      })
    },

    // XX牧场XX年每月单头牛用水量对比
    getChart4() {
      GetReportform(this.getChart4Parm).then(response => {
        console.log('图4', response)
        // this.chart_data4 = response.data.chart_data
        this.chart_data4 = {
          data1:[
            {data:[10,20,30,40,50]},
            {data:[20,30,40,50,60]},
            {data:[30,40,50,60,70]},
          ],
          data_name:["马鞍山牧场", "汶上牧场", "商河牧场"],
          xdata:["2023-01", "2023-02", "2023-03", "2023-04", "2023-05"]
        }
        this.roadChart4(this.chart_data4)
      })
    },

    // XX月部门统计
    getChart5() {
      GetReportform(this.getChart5Parm).then(response => {
        console.log('图5', response)
        // this.chart_data5 = response.data.chart_data
        this.chart_data5 = {
          data1:[10,20,30,40,50],
          data2:[20,30,40,50,60],
          xdata:["马鞍山牧场挤奶处", "和林牧场挤奶处", "蚌埠牧场挤奶处", "塞一牧场挤奶处", "塞二牧场挤奶处"]
        }
        this.roadChart5(this.chart_data5)
      })
    },
    // XX牧场XX年每月用水量对比
    getChart6() {
      GetReportform(this.getChart6Parm).then(response => {
        console.log('图6', response)
        // this.chart_data6 = response.data.chart_data
        this.chart_data6 = {
          data1:[10,20,30,40,50],
          data2:[20,30,40,50,60],
          data3:[30,40,50,60,70],
          xdata:["2023-01", "2023-02", "2023-03", "2023-04", "2023-05"]
        }
        this.roadChart6(this.chart_data6)
      })
    },
    // XX月每日用水量
    getChart7() {
      GetReportform(this.getChart7Parm).then(response => {
        console.log('图7', response)
        // this.chart_data7 = response.data.chart_data
        this.chart_data7 = {
          data1:[
            {data:[10,20,30,40,50]},
            {data:[20,30,40,50,60]},
            {data:[30,40,50,60,70]},
          ],
          data_name:["马鞍山牧场", "汶上牧场", "商河牧场"],
          xdata:["2023-01", "2023-02", "2023-03", "2023-04", "2023-05"]
        }
        this.roadChart7(this.chart_data7)
      })
    },
    // 各牧场年度用水量对比
    roadChart1(chart_data) {
      if (this.chart1 != null) {
        this.chart1.dispose()
      }
      this.chart1 = echarts.init(document.getElementById('chart1'))
      var option = {
        title: { text: '各牧场年度用电量对比', textStyle: { color: '#769cfc' }},
        tooltip: { trigger: 'axis' },
        legend: {
          data: ['今年用量', '迄今预算'],
          right: 40
        },
        color: ['#2dc0e8', '#769cfc'],
        grid: { left: '3%', right: '10%', bottom: '4%', containLabel: true },
        xAxis: [{ type: 'category',  name: '牧场',data: chart_data.xdata, axisLabel: { interval: 0, rotate: 30 }}],
        yAxis: [{ type: 'value', name: '电量(度)', axisLabel: { formatter: '{value}万' }}],
        series: [
          {
            name: '今年用量',
            type: 'bar',
            data: chart_data.data1,
            barMaxWidth:20,
            emphasis: { label: { show: true, position: 'inside' }}
          },
          {
            name: '迄今预算',
            type: 'bar',
            barMaxWidth:20,
            data: chart_data.data2,
            emphasis: { label: { show: true, position: 'inside' }}
          }

        ]
      }
      this.chart1.setOption(option)
      window.onresize = function() {
        this.chart1.resize()
      }
      var that = this
      this.chart1.on('click', function(param, i) {
        console.log(param)
      })
    },
    // 单头牛水量
    roadChart2(chart_data) {
      if (this.chart2 != null) {
        this.chart2.dispose()
      }
      this.chart2 = echarts.init(document.getElementById('chart2'))
      var option = {
        title: { text: '单头牛电量', left:'center',textStyle: { color: '#769cfc' }},
        tooltip: { trigger: 'axis' },
        legend: {
          data: ['实际费用', '去年同期'],
          right: 40
        },
        color: ['#2dc0e8', '#769cfc'],
        grid: { left: '3%', right: '10%', bottom: '4%', containLabel: true },
        xAxis: [{ type: 'category',  name: '牧场',data: chart_data.xdata, axisLabel: { interval: 0, rotate: 30 }}],
        yAxis: [{ type: 'value', name: '用量(度)'}],
        series: [
          {
            name: '实际费用',
            type: 'bar',
            data: chart_data.data1,
            emphasis: { label: { show: true, position: 'inside' }},
            barMaxWidth:20,
            markLine:{ data:[ {yAxis:20} ] }
          },
          {
            name: '去年同期',
            type: 'bar',
            data: chart_data.data2,
            emphasis: { label: { show: true, position: 'inside' }},
            barMaxWidth:20
          }

        ]
      }
      this.chart2.setOption(option)
      window.onresize = function() {
        this.chart2.resize()
      }
      var that = this
      this.chart2.on('click', function(param, i) {
        console.log(param)
      })
    },
    // 单头牛电费
    roadChart3(chart_data) {
      if (this.chart3 != null) {
        this.chart3.dispose()
      }
      this.chart3 = echarts.init(document.getElementById('chart3'))
      var option = {
        title: { text: '单头牛电费', left:'center',textStyle: { color: '#769cfc' }},
        tooltip: { trigger: 'axis' },
        legend: {
          data: ['实际费用'],
          right: 40
        },
        color: ['#2dc0e8', '#FFB800'],
        grid: { left: '3%', right: '10%', bottom: '4%', containLabel: true },
        xAxis: [{ type: 'category',  name: '牧场',data: chart_data.xdata, axisLabel: { interval: 0, rotate: 30 }}],
        yAxis: [{ type: 'value', name: '价格(元)'}],
        series: [
          {
            name: '实际费用',
            type: 'bar',
            data: chart_data.data1,
            emphasis: { label: { show: true, position: 'inside' }},
            barMaxWidth:20,
            markLine:{ data:[ {yAxis:20} ] }
          }
        ]
      }
      this.chart3.setOption(option)
      window.onresize = function() {
        this.chart3.resize()
      }
      var that = this
      this.chart3.on('click', function(param, i) {
        console.log(param)
      })
    },
    // 各牧场XX年每月单头牛用水量对比
    roadChart4(chart_data) {
      if (this.chart4 != null) {
        this.chart4.dispose()
      }
      this.chart4 = echarts.init(document.getElementById('chart4'))
      var text = '各牧场' + parseTime(this.yearDate, '{y}') + '年每月单头牛用水量对比'
      var option = {
        title: { text: text, left:'left',textStyle: { color: '#769cfc' }},
        tooltip: { trigger: 'axis' },
        legend: {
          data: chart_data.data_name,
          left: 40,
          bottom:0
        },
        color: ['#2dc0e8', '#769cfc', '#FFB800'],
        grid: { left: '3%', right: '10%', bottom: '4%', containLabel: true },
        xAxis: [{ type: 'category',  name: '月份',data: chart_data.xdata, axisLabel: { interval: 0, rotate: 30 }}],
        yAxis: [{ type: 'value', name: '千瓦'}],
        series: (function() {
          var serie = []
          if(chart_data.data1 !== null){
            for (var i = 0; i < chart_data.data1.length; i++) {
              var item = {
                name: chart_data.data_name[i],
                type: 'line',
                data: chart_data.data1[i].data
              }
              serie.push(item)
            }
          }
          return serie
        }())
      }
      this.chart4.setOption(option)
      window.onresize = function() {
        this.chart4.resize()
      }
      var that = this
      that.chart4.on('click', function(param, i) {
        console.log(param)
        that.getChart5()
      })
    },
    // XX月部门统计
    roadChart5(chart_data) {
      if (this.chart5 != null) {
        this.chart5.dispose()
      }
      this.chart5 = echarts.init(document.getElementById('chart5'))
      var text = parseTime(new Date(), '{m}') + '月部门统计'
      var option = {
        title: { text: text, left:'center',textStyle: { color: '#769cfc' }},
        tooltip: { trigger: 'axis' },
        legend: {
          data: ['实际', '预算'],
          right: 40,
          bottom:0
        },
        color: ['#2dc0e8', '#769cfc'],
        grid: { left: '3%', right: '10%', bottom: '4%', containLabel: true },
        xAxis: [{ type: 'category',  name: '部门',data: chart_data.xdata, axisLabel: { interval: 0, rotate: 30 }}],
        yAxis: [{ type: 'value',name: '千瓦', axisLabel: { formatter:'{value} 万'}}],
        series: [
          {
            name: '实际',
            type: 'bar',
            data: chart_data.data1,
            emphasis: { label: { show: true, position: 'inside' }},
            barMaxWidth:20
          },
          {
            name: '预算',
            type: 'bar',
            data: chart_data.data2,
            emphasis: { label: { show: true, position: 'inside' }},
            barMaxWidth:20
          }
        ]
      }
      this.chart5.setOption(option)
      window.onresize = function() {
        this.chart5.resize()
      }
      var that = this
      this.chart5.on('click', function(param, i) {
        console.log(param)
      })
    },
    // XX牧场XX年每月用水量对比
    roadChart6(chart_data) {
      if (this.chart6 != null) {
        this.chart6.dispose()
      }
      this.chart6 = echarts.init(document.getElementById('chart6'))
      var option = {
        title: { text: 'XX牧场XX年每月用电量对比', left:'center',textStyle: { color: '#769cfc' }},
        tooltip: { trigger: 'axis' },
        legend: {
          data: ['去年同期用量', '今年用量','预算'],
          right: 40,
          bottom:0
        },
        color: ['#2dc0e8', '#769cfc', '#FFB800'],
        grid: { left: '3%', right: '10%', bottom: '4%', containLabel: true },
        xAxis: [{ type: 'category',  name: '月份',data: chart_data.xdata, axisLabel: { interval: 0, rotate: 30 }}],
        yAxis: [{ type: 'value',name: '电量(千瓦)'}],
        series: [
          {
            name: '去年同期用量',
            type: 'line',
            data: chart_data.data1,
            emphasis: { label: { show: true, position: 'inside' }},
            barMaxWidth:20
          },
          {
            name: '今年用量',
            type: 'line',
            data: chart_data.data2,
            emphasis: { label: { show: true, position: 'inside' }},
            barMaxWidth:20
          },
          {
            name: '预算',
            type: 'line',
            data: chart_data.data3,
            emphasis: { label: { show: true, position: 'inside' }},
            barMaxWidth:20
          }
        ]
      }
      this.chart6.setOption(option)
      window.onresize = function() {
        this.chart6.resize()
      }
      var that = this
      this.chart6.on('click', function(param, i) {
        console.log(param)
      })
    },
    // XX月每日用水量
    roadChart7(chart_data) {
      if (this.chart7 != null) {
        this.chart7.dispose()
      }
      this.chart7 = echarts.init(document.getElementById('chart7'))
      var text = parseTime(new Date(), '{m}') + '月每日用水量'
      var option = {
        title: { text: text, left:'left',textStyle: { color: '#769cfc' }},
        tooltip: { trigger: 'axis' },
        legend: {
          data: chart_data.data_name,
          left: 40,
          bottom:0
        },
        color: ['#2dc0e8', '#769cfc', '#FFB800'],
        grid: { left: '3%', right: '10%', bottom: '4%', containLabel: true },
        xAxis: [{ type: 'category',  name: '日',data: chart_data.xdata, axisLabel: { interval: 0, rotate: 30 }}],
        yAxis: [{ type: 'value', name: '电量(千瓦)'}],
        series: (function() {
          var serie = []
          if(chart_data.data1 !== null){
            for (var i = 0; i < chart_data.data1.length; i++) {
              var item = {
                name: chart_data.data_name[i],
                type: 'line',
                data: chart_data.data1[i].data
              }
              serie.push(item)
            }
          }
          return serie
        }())
      }
      this.chart7.setOption(option)
      window.onresize = function() {
        this.chart7.resize()
      }
      var that = this
      this.chart7.on('click', function(param, i) {
        console.log(param)
      })
    },

  }
}
</script>
<style>
.el-row {
    margin-bottom: 40px;
    &:last-child {
      margin-bottom: 0;
    }
  }
</style>

<style lang="scss" scoped>
.group{
  float: right;margin-bottom: 20px;
}
</style>
